--
-- GaluchoTrailer
-- Specialization forGalucho Trailer
--
-- @author PeterJ
--
-- edited by PeterJ - 30/10/2018
--
--


GaluchoTrailer = {};

function GaluchoTrailer.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Foldable, specializations) and SpecializationUtil.hasSpecialization(TensionBelts, specializations);
end;

function GaluchoTrailer:load(saveGame)

	self.getIsFoldAllowed = Utils.overwrittenFunction(self.getIsFoldAllowed, GaluchoTrailer.getIsFoldAllowed);
	self.getIsFoldMiddleAllowed = Utils.overwrittenFunction(self.getIsFoldMiddleAllowed, GaluchoTrailer.getIsFoldMiddleAllowed);

	self.foldOnTip = true;
	self.releaseBeltsOnTip = true;
	self.releaseBeltsOnFold = true;

end;

function GaluchoTrailer:delete()
end;

function GaluchoTrailer:readStream(streamId, connection)		
end;

function GaluchoTrailer:writeStream(streamId, connection)
end;

function GaluchoTrailer:keyEvent(unicode, sym, modifier, isDown)
end;

function GaluchoTrailer:mouseEvent(posX, posY, isDown, isUp, button)
end;

function GaluchoTrailer:update(dt)
end;

function GaluchoTrailer:updateTick(dt)
	if self:getIsActive() then
		if self.tipState ~= Trailer.TIPSTATE_CLOSED then
			if self.foldOnTip then
				if self.foldAnimTime > 0 then
					self:setFoldState(self:getToggledFoldDirection(), false);
					self.foldOnTip = false;
				end;
			end;
			if self.releaseBeltsOnTip and self.areBeltsFasten then
				for _, belt in pairs(self.tensionBelts.sortedBelts) do
					self:setTensionBeltsActive(false, belt.id, false)
				end;
				self.releaseBeltsOnTip = false;
			end;
		else
			self.foldOnTip = true;
			self.releaseBeltsOnTip = true;
		end;
		if self.areBeltsFasten then
			if self.releaseBeltsOnFold then
				if self.foldAnimTime > 0 and  self.foldAnimTime < self.foldMiddleAnimTime then
					for _, belt in pairs(self.tensionBelts.sortedBelts) do
						self:setTensionBeltsActive(false, belt.id, false)
					end;
					self.releaseBeltsOnFold = false;
				end;
			else
				if self.foldAnimTime == 0 or self.foldAnimTime < self.foldMiddleAnimTime then
					self.releaseBeltsOnFold = true;
				end;
			end;
		end;
	end;
end;

function GaluchoTrailer:draw()
end;

function GaluchoTrailer:getIsFoldAllowed(superFunc, onAiTurnOn)
    if self.onlyFoldOnDetach and self.attacherVehicle ~= nil then
        return false;
    end;
    if self.onlyFoldOnEmpty and self:getFillLevel() > 0 then
        return false;
    end;
	if self.tipState == Trailer.TIPSTATE_CLOSED then
        return superFunc(self);
    else
        return false;
	end;
    if superFunc ~= nil then
        return superFunc(self);
    end
    return true;
end;

function GaluchoTrailer:getIsFoldMiddleAllowed(superFunc)
    if self.onlyFoldOnEmpty and self:getFillLevel() > 0 then
        return false;
    end;
	if self.tipState == Trailer.TIPSTATE_CLOSED then
        return superFunc(self);
    else
        return false;
	end;
    if superFunc ~= nil then
        return superFunc(self);
    end;
	return true;
end;


function GaluchoTrailer:onAttach(attacherVehicle)

end;

function GaluchoTrailer:onDetach()
end;
